namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    
    [Serialized]    
    [RequireComponent(typeof(PropertyAuthComponent))]
    [RequireComponent(typeof(MinimapComponent))]
    [RequireComponent(typeof(HousingComponent))]
    [RequireComponent(typeof(SolidGroundComponent))]
    [RequireComponent(typeof(RoomRequirementsComponent))]
    [RequireRoomContainment]
    [RequireRoomVolume(16)]
    [RequireRoomMaterialTier(2, 10)]                              
    public partial class ShowerObject : WorldObject
    {

    static ShowerObject()
        {
                        WorldObject.AddOccupancy<ShowerObject>(new List<BlockOccupancy>()
                {

                new BlockOccupancy(new Vector3i(0, 0, 0), typeof(SolidWorldObjectBlock)),
                new BlockOccupancy(new Vector3i(0, 1, 0), typeof(SolidWorldObjectBlock)),
                new BlockOccupancy(new Vector3i(0, 2, 0), typeof(SolidWorldObjectBlock)),
                }); 
        }
    public override string FriendlyName { get { return "Shower"; } } 


    protected override void Initialize()
        {
            this.GetComponent<MinimapComponent>().Initialize("Housing");                                 
            this.GetComponent<HousingComponent>().Set(ShowerItem.HousingVal);                                


        }

    public override void Destroy()
        {
            base.Destroy();
        }
       
    }

    [Serialized]
    public partial class ShowerItem :
        WorldObjectItem<ShowerObject> 
    {
        public override string FriendlyName { get { return "Shower"; } } 
        public override string Description  { get { return  ""; } }

        static ShowerItem()
        {

        }

        [TooltipChildren] public HousingValue HousingTooltip { get { return HousingVal; } }
        [TooltipChildren] public static HousingValue HousingVal { get { return new HousingValue() 
                                                {
                                                    Category = "Bathroom",
                                                    Val = 4,                                   
                                                    TypeForRoomLimit = "Washing", 
                                                    DiminishingReturnPercent = 0    
        };}}
    }


    [RequiresSkill(typeof(MechanicalEngineeringSkill), 2)]
    public partial class ShowerRecipe : Recipe
    {
        public ShowerRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<ShowerItem>(),
            };

            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<PlasticItem>(typeof(MechanicsAssemblyEfficiencySkill), 20, MechanicsAssemblyEfficiencySkill.MultiplicativeStrategy),   
                new CraftingElement<TallowItem>(typeof(MechanicsAssemblyEfficiencySkill), 5, MechanicsAssemblyEfficiencySkill.MultiplicativeStrategy),
                new CraftingElement<SteelPipeItem>(5),
                new CraftingElement<CopperPipeItem>(5),
            };
            SkillModifiedValue value = new SkillModifiedValue(120, MechanicsAssemblySpeedSkill.MultiplicativeStrategy, typeof(MechanicsAssemblySpeedSkill), Localizer.Do("craft time"));
            SkillModifiedValueManager.AddBenefitForObject(typeof(ShowerRecipe), Item.Get<ShowerItem>().UILink(), value);
            SkillModifiedValueManager.AddSkillBenefit(Item.Get<ShowerItem>().UILink(), value);
            this.CraftMinutes = value;
            this.Initialize("Shower", typeof(ShowerRecipe));
            CraftingComponent.AddRecipe(typeof(MachineShopObject), this);
        }
    }
}